#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru" // added Support & Resistance at static levels by ArshadFX

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 Red
//---- indicator parameters
extern int ExtDepth=12;
extern bool ShowBreakup    =1;      // Show Breakup of ZigZag static levels / Support Resistance
extern bool   alertsOn        = false;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//---- indicator buffers
double zzL[], zzH[], zz[], UP[], DN[], trend[];

int init()  // -------------- Custom indicator initialization function
  {
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_SECTION); //---- drawing settings
   SetIndexStyle(1,DRAW_ARROW);  SetIndexArrow(1,228);   
   SetIndexStyle(2,DRAW_ARROW);  SetIndexArrow(2,230);
   SetIndexStyle(3,DRAW_LINE);  
   SetIndexStyle(4,DRAW_LINE); 

   SetIndexBuffer(0,zz);      //---- indicator buffers mapping
   SetIndexBuffer(1,zzH);
   SetIndexBuffer(2,zzL);
   SetIndexBuffer(3,UP);
   SetIndexBuffer(4,DN);
   SetIndexBuffer(5,trend);
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   IndicatorShortName("DT_ZZ("+ExtDepth+")");
   return(0);
  }

int start()  // ----------------------------------- Main function call
  {
   int    i,x,shift,pos,lasthighpos,lastlowpos,curhighpos,curlowpos;
   double curlow,curhigh,lasthigh,lastlow, highS, lowS;  // highS= HighStatic ... 
   double min, max;
   ArrayInitialize(zz,0.0);   ArrayInitialize(zzL,0.0);   ArrayInitialize(zzH,0.0);
   
   lasthighpos=Bars-1; lastlowpos=Bars-1;   lastlow=Low[Bars];lasthigh=High[Bars];
   
   for(shift=Bars-ExtDepth; shift>=0; shift--)     // loop of 12 block 
    {
      curlowpos=Lowest(NULL,0,MODE_LOW,ExtDepth,shift);        // lowest price of 12 block
      curlow=Low[curlowpos];                                   // lowest bar index no
      curhighpos=Highest(NULL,0,MODE_HIGH,ExtDepth,shift);     // highest price of 12 block
      curhigh=High[curhighpos];                                // highest bar index no
      //------------------------------------------------
      if( curlow>=lastlow ) { lastlow=curlow; } // price is going up,
      else
         { 
         if( lasthighpos>curlowpos  ) 
            {
            zzL[curlowpos]=curlow;
            min=100000; pos=lasthighpos;
            for(i=lasthighpos; i>=curlowpos; i--)
               {
               if (zzL[i]==0.0) continue;
               if (zzL[i]<min) { min=zzL[i]; pos=i; }
               zz[i]=0.0;
               } 
            zz[pos]=min; highS=max; 
            } 
         lastlowpos=curlowpos;
         lastlow=curlow; 
         }
      //--- high
      if( curhigh<=lasthigh )  { lasthigh=curhigh;}
      else
         {// We go upwards
         if( lastlowpos>curhighpos ) 
            {
            zzH[curhighpos]=curhigh;
            max=-100000; pos=lastlowpos;
            for(i=lastlowpos; i>=curhighpos; i--)
               { 
               if (zzH[i]==0.0) continue;
               if (zzH[i]>max) { max=zzH[i]; pos=i; }
               zz[i]=0.0;
               } 
            zz[pos]=max; lowS=min; 
            }  
         lasthighpos=curhighpos;
         lasthigh=curhigh;    
         }       
//   Added for displaying Breakups ------------- 17th of May, 2009
   if (ShowBreakup)
      {
      for(x=lasthighpos; x>=shift; x--)
         {
         UP[x]=highS; 
         }
      for(x=lastlowpos; x>=shift; x--)
         {
         DN[x]=lowS; 
         }
      }
   }
   for(shift=Bars-ExtDepth; shift>=0; shift--) 
   {
      trend[shift] = trend[shift+1];
      if (zzH[shift]!=0) trend[shift] =  1;
      if (zzL[shift]!=0) trend[shift] = -1;
   }
   manageAlerts();
 return(0);
}
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
         if (trend[0] ==  1) doAlert(0,"up");
         if (trend[0] == -1) doAlert(0,"down");
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DT ZZ SupRes current trend is ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," DT ZZ SupRes current trend"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," DT ZZ SupRes current trend "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}